#!/usr/bin/perl

eval 'exec /usr/bin/perl  -S $0 ${1+"$@"}'
    if 0; # not running under some shell

use strict;
use warnings;
use lib qw/lib/;
use Urb::Dom;
use Urb::Dom::Fitness;
use YAML;

for my $path_yaml (@ARGV)
{
    my $dom = new Urb::Dom;
    $dom->Deserialise (YAML::LoadFile ($path_yaml));

    my $assessor = new Urb::Dom::Fitness;

    # calculate a score, print and write out a file
    my $score = sprintf ("%.40f", $assessor->_apply ($dom));

    print "$score\n";

    unlink "$path_yaml.score";
    open SCORE, ">$path_yaml.score";
    print SCORE "$score\n";
    close SCORE;

    # get list of failures generated during scoring, write to file
    my @failures = $dom->Failures;

    unlink "$path_yaml.fails";
    open FAILS, ">$path_yaml.fails";
    print FAILS join "\n", @failures, '';
    close FAILS;
}

0;
