#!/usr/bin/perl

eval 'exec /usr/bin/perl  -S $0 ${1+"$@"}'
    if 0; # not running under some shell

use strict;
use warnings;
use lib qw/lib/;
use Urb::Dom;
use Urb::Dom::Fitness;
use YAML;

my $assessor = new Urb::Dom::Fitness;

for my $path_yaml (@ARGV)
{
    my $dom0 = new Urb::Dom;
    $dom0->Deserialise (YAML::LoadFile ($path_yaml));
    my $dom1 = $dom0->Clone;
    my $dom2 = $dom0->Clone;
    my $dom3 = $dom0->Clone;

    $dom0->Straighten_Recursive (0);
    $dom1->Straighten_Recursive (1);
    $dom2->Straighten_Recursive (2);
    $dom3->Straighten_Recursive (3);
    my @sorted = sort {$assessor->_apply ($a) <=> $assessor->_apply ($b)} ($dom0, $dom1, $dom2, $dom3);

    my $dom = pop @sorted;
    YAML::DumpFile ($path_yaml, $dom->Serialise);
}

0;
